Index: pjproject/trunk/README.txt
===================================================================
--- pjproject/trunk/README.txt	(revision 710)
+++ pjproject/trunk/README.txt	(revision 787)
@@ -1,7 +1,7 @@
-
 
 Getting Started: Building and Using PJSIP and PJMEDIA
 
-   [Last Update: Sept 13, 2006]
+   [Last Update: $Date: 2006-10-21 19:14:22 +0100 (Sat, 21 Oct 2006) $]
+
      _________________________________________________________________
 
@@ -12,11 +12,12 @@
 
 Quick Info
-
-   Building with GNU tools
+     _________________________________________________________________
+
+   Building with GNU tools (Linux, *BSD, MacOS X, mingw, etc.)
           Generally these should be all that are needed to build the libraries,
           applications, and samples:
 
-   $ ./configure
-   $ make dep && make clean && make
+	   $ ./configure
+	   $ make dep && make clean && make
 
    Building Win32 Target with Microsoft Visual Studio
@@ -34,7 +35,12 @@
          3. build the pjsua_wince application.
 
-   With Visual Studio for Win32 target and the GNU build systems, the output
-   libraries will be put in lib directory under each projects, and the output
-   binaries will be put in bin directory under each projects.
+   Locating Output Binaries/Libraries
+          Libraries will be put in lib directory, and binaries will be put in
+          bin directory, under each projects.
+
+   Running the Applications
+          After successful build, you can try running pjsua application on
+          pjsip-apps/bin     directory.     PJSUA     manual     is    in
+          http://www.pjsip.org/pjsua.htm.
 
 
@@ -56,5 +62,6 @@
      2.2 Disk Space Requirements
 
-   3. Building Linux, *nix, *BSD, and MacOS X Targets with GNU Build Systems
+   3.  Building Linux, *nix, *BSD, and MacOS X Targets with GNU Build
+   Systems
 
      3.1 Supported Targets
@@ -67,4 +74,6 @@
 
      3.5 Cross Compilation
+
+     3.6 Build Customizations
 
    4. Building for Windows Targets with Microsoft Visual Studio
@@ -277,6 +286,18 @@
      _________________________________________________________________
 
-2.1 config_site.h file
-     _________________________________________________________________
+2.1 Create config_site.h file
+     _________________________________________________________________
+
+   Before source files can be built, the pjlib/include/pj/config_site.h file
+   must be created (it can just be an empty file).
+
+   Note:
+          When the Makefile based build system is used, this process is taken
+          care by the Makefiles. But when non-Makefile based build system (such
+          as Visual Studio) is used, the config_site.h file must be created
+          manually.
+
+
+What is config_site.h File
 
    The pjlib/include/pj/config_site.h contains local customizations to the
@@ -294,7 +315,8 @@
    Please find list of configuration macros that can be overriden from these
    files:
-     * pjlib/config.h file
-     * pjmedia/config.h file
-     * pjsip/sip_config.h file
+     * PJLIB Configuration (the pjlib/config.h file)
+     * PJLIB-UTIL Configuration (the pjlib-util/config.h file)
+     * PJMEDIA Configuration (the pjmedia/config.h file)
+     * PJSIP Configuration (the pjsip/sip_config.h file)
 
    A     sample    config_site.h    file    is    also    available    in
@@ -323,5 +345,5 @@
 
    The building process needs:
-     * about 50-60 MB of disk space to store the uncompressed source files, and
+   about 50-60 MB of disk space to store the uncompressed source files, and
      * about 30-50 MB of additional space for building each target
 
@@ -416,9 +438,9 @@
    obtained by executing ./configure --help.
 
-   For example, to build the libraries/application in debug mode:
-
-
-
-   $ ./configure CFLAGS="-g"
+   Below is an example of specifying CFLAGS in configure:
+
+
+
+   $ ./configure CFLAGS="-O3 -DNDEBUG -msoft-float -fno-builtin"
    ...
 
@@ -427,10 +449,17 @@
      _________________________________________________________________
 
-   (.. to be completed)
-
-
-
-   $ ./configure --target=powerpc-linux-unknown
+   Cross compilation should be supported, using the usual autoconf syntax:
+
+
+
+   $ ./configure --host=arm-elf-linux
    ...
+
+   Since cross-compilation is not tested as often as the "normal" build, please
+   watch for the ./configure output for incorrect settings (well ideally this
+   should be done for normal build too).
+
+   Please refer to Porting Guide for further information about porting PJ
+   software.
 
 
@@ -474,4 +503,20 @@
 
 
+  3.6 Build Customizations
+     _________________________________________________________________
+
+   Build features can be customized by specifying the options when running
+   ./configure as described in Running Configure above.
+
+   In addition, additional CFLAGS and LDFLAGS options can be put in user.mak
+   file in PJ root directory (this file may need to be created if it doesn't
+   exist). Below is a sample of user.mak file contents:
+
+
+
+   export CFLAGS += -msoft-float -fno-builtin
+   export LDFLAGS +=
+
+
 4. Building for Windows Targets with Microsoft Visual Studio
      _________________________________________________________________
@@ -486,5 +531,8 @@
      * Microsoft Visual Studio .NET 2002,
      * Microsoft Visual Studio .NET 2003,
-     * Microsoft Visual C++ Express 2005 with Platform SDK and DirectX SDK,
+     * Microsoft Visual C++ Express 2005 with Platform SDK,
+     * DirectX SDK is needed if PJMEDIA DirectSound sound backend is explicitly
+       choosen (default is using PortAudio, which uses DirectSound via run-time
+       bindings, so DirectX SDK is not needed)
 
    For the host, the following are required:
@@ -699,4 +747,17 @@
 
 
+    6. Link with system spesific libraries:
+
+        Windows
+                Add (among other things): wsock32.lib, ws2_32.lib, ole32.lib,
+                dsound.lib
+
+        Linux, *nix, *BSD
+                Add (among other things): '-lpthread -lm' (at least).
+
+        MacOS X
+                Add (among other things): '-framework CoreAudio -lpthread -lm'.
+
+
 Appendix I: Common Problems/Frequently Asked Question (FAQ)
      _________________________________________________________________
@@ -713,7 +774,11 @@
 
 
-  Thanks for using PJ libraries and for reading this document. Please
-  send feedbacks or general comments to <bennylp at pjsip dot org>.
-
-  Benny Prijono
-
+
+
+
+     _________________________________________________________________
+
+   Feedback:
+          Thanks for using PJ libraries and for reading this document. Please
+          send feedbacks or general comments to <bennylp at pjsip dot org>.
+