Index: /pjproject/trunk/pjsip-apps/build/Footprint.mak
===================================================================
--- /pjproject/trunk/pjsip-apps/build/Footprint.mak	(revision 824)
+++ /pjproject/trunk/pjsip-apps/build/Footprint.mak	(revision 825)
@@ -30,6 +30,6 @@
 		$(subst /,$(HOST_PSEP),$(PJSIP_SIMPLE_LIB)) \
 		$(subst /,$(HOST_PSEP),$(PJSIP_LIB)) \
+		$(subst /,$(HOST_PSEP),$(PJMEDIA_LIB)) \
 		$(subst /,$(HOST_PSEP),$(PJMEDIA_CODEC_LIB)) \
-		$(subst /,$(HOST_PSEP),$(PJMEDIA_LIB)) \
 		$(subst /,$(HOST_PSEP),$(PJLIB_UTIL_LIB)) \
 		$(subst /,$(HOST_PSEP),$(PJLIB_LIB))
Index: /pjproject/trunk/pjsip-apps/build/get-footprint.py
===================================================================
--- /pjproject/trunk/pjsip-apps/build/get-footprint.py	(revision 824)
+++ /pjproject/trunk/pjsip-apps/build/get-footprint.py	(revision 825)
@@ -43,9 +43,11 @@
     ['HAS_PJLIB_SCANNER',	'PJLIB-UTIL text scanner (needed by SIP parser)'],
     ['HAS_PJLIB_XML',		'PJLIB-UTIL tiny XML (parsing and API) (needs text scanner)'],
+    ['HAS_PJLIB_DNS',		'PJLIB-UTIL DNS packet and parsing'],
+    ['HAS_PJLIB_RESOLVER',	'PJLIB-UTIL Asynchronous DNS resolver/caching engine'],
 
     # PJSIP
     ['HAS_PJSIP_CORE_MSG_ELEM',	'PJSIP Core - Messaging Elements and Parsing (message, headers, SIP URI, TEL URI/RFC 3966, etc.)'],
     ['HAS_PJSIP_CORE',		'PJSIP Core - Endpoint (transport management, module management, event distribution, etc.)'],
-    ['HAS_PJSIP_CORE_MSG_UTIL',	'PJSIP Core - Stateless operations, server resolution and fail-over'],
+    ['HAS_PJSIP_CORE_MSG_UTIL',	'PJSIP Core - Stateless operations, SIP SRV, server resolution and fail-over'],
     ['HAS_PJSIP_UDP_TRANSPORT',	'PJSIP UDP transport'],
     ['',			'Subtotal: A minimalistic SIP application (parsing, UDP transport+STUN, no transaction)'],
@@ -100,4 +102,5 @@
     ['HAS_PJMEDIA_GSM_CODEC',	'PJMEDIA GSM codec (including PLC)'],
     ['HAS_PJMEDIA_SPEEX_CODEC',	'PJMEDIA Speex codec (narrowband, wideband, ultra-wideband)'],
+    ['HAS_PJMEDIA_ILBC_CODEC',	'PJMEDIA iLBC codec'],
 
     # Total
@@ -218,5 +221,5 @@
     output.write('\n<H3>&lt;pj/config.site.h&gt;</H3>\n')
     output.write('<tt>\n')
-    f = os.popen('cpp -dM ../../pjlib/include/pj/config_site.h | grep PJ')
+    f = os.popen('cpp -dM -I../../pjlib/include ../../pjlib/include/pj/config_site.h | grep PJ')
     s = f.readlines()
     for l in s:
Index: /pjproject/trunk/pjsip-apps/src/samples/footprint.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/footprint.c	(revision 824)
+++ /pjproject/trunk/pjsip-apps/src/samples/footprint.c	(revision 825)
@@ -43,4 +43,6 @@
 #define HAS_PJLIB_XML
 #define HAS_PJLIB_SCANNER
+#define HAS_PJLIB_DNS
+#define HAS_PJLIB_RESOLVER
 
 #define HAS_PJSIP_CORE_MSG_ELEM
@@ -83,4 +85,5 @@
 #define HAS_PJMEDIA_GSM_CODEC
 #define HAS_PJMEDIA_SPEEX_CODEC
+#define HAS_PJMEDIA_ILBC_CODEC
 #endif
 
@@ -152,4 +155,20 @@
     pj_scan_get_newline(NULL);
     pj_scan_restore_state(NULL, NULL);
+#endif
+
+#ifdef HAS_PJLIB_DNS
+    pj_dns_make_query(NULL, NULL, 0, 0, NULL);
+    pj_dns_parse_packet(NULL, NULL, 0, NULL);
+    pj_dns_packet_dup(NULL, NULL, NULL);
+#endif
+
+#ifdef HAS_PJLIB_RESOLVER
+    pj_dns_resolver_create(NULL, NULL, 0, NULL, NULL, NULL);
+    pj_dns_resolver_set_ns(NULL, 0, NULL, NULL);
+    pj_dns_resolver_handle_events(NULL, NULL);
+    pj_dns_resolver_destroy(NULL, 0);
+    pj_dns_resolver_start_query(NULL, NULL, 0, 0, NULL, NULL, NULL);
+    pj_dns_resolver_cancel_query(NULL, 0);
+    pj_dns_resolver_add_entry(NULL, NULL, 0);
 #endif
 
@@ -352,5 +371,5 @@
     pjsip_pres_init_module(NULL, NULL);
     pjsip_pres_instance();
-    pjsip_pres_create_uac(NULL, NULL, NULL);
+    pjsip_pres_create_uac(NULL, NULL, 0, NULL);
     pjsip_pres_create_uas(NULL, NULL, NULL, NULL);
     pjsip_pres_terminate(NULL, PJ_FALSE);
@@ -526,4 +545,9 @@
 #endif
 
+#ifdef HAS_PJMEDIA_ILBC_CODEC
+    pjmedia_codec_ilbc_init(NULL, 0);
+    pjmedia_codec_ilbc_deinit();
+#endif
+
     return 0;
 }